Require Le.
Require Lt.
Require Plus.
Require Compare_dec.

(* The statement is identical to Eindhoven.POCKLINGTON.lemmas.le_witness *)
(* but for the sort.                                                     *)
Lemma le_witness: (x,y:nat)(le x y)->{q:nat | (plus x q)=y}.
Proof.
 Induction x;
  [ Intros;
    Exists y;
    Reflexivity
  | Intros;
    Induction y;
     [ ElimType False;
       Inversion H0
     | Elim (H y);
        [ Intros;
          Exists x0;
          Simpl;
          Apply (f_equal (?) (?) (S));
          Exact p
        | Auto with arith
        ]
     ]
  ].
Qed.

Lemma not_lt_plus: (a,b:nat)~(lt (plus a b) a).
Proof.
 Intros ;
 Apply le_not_lt;
 Apply le_plus_l.
Qed.

Theorem ge_eq_sumbool_gt: (n,m:nat)(ge n m) -> {n=m}+{(gt n m)}. 
Proof.
 Intros;
 Elim (lt_eq_lt_dec n m);
  [ Intro;
    Case a;
     [ Intro;
       Elim (le_not_lt ? ? H l)
     | Left;
       Assumption
     ]
  | Right;
    Assumption
  ].
Qed.

Theorem plus_neq_O_neq_or_neq:
 (a,b:nat)~(plus a b)=O -> {~a=O}+{~b=O}.
Proof.
 Intros a b;
 Case a;
  [ Right;
    Assumption
  | Left;
    Intro;
    Discriminate
  ].
Qed.
